function opt1 = AmPut(s,x,r,q,sig,t,n)

dt  = t/n; 
u = exp(sig*sqrt(dt)); 
d = exp(-sig*sqrt(dt)); 
a = exp((r-q)*dt); 
p = (a-d)/(u-d); 

for j = 0:n;
  pr(j+1,2) = s*(d^(n-j))*(u^j);
  opt(j+1,2) = max(x-pr(j+1,2),0);
end;   

for i = n-1:-1:0; 
    for j = 0:i;
        pr(j+1,1) = s*(d^(i-j))*(u^j);
        opt(j+1,1) = max( x-pr(j+1,1),(p*opt(j+2,2)+(1-p)*opt(j+1,2))*exp(-r*dt));
    end
opt(:,2) = opt(:,1);
pr(:,2) = pr(:,1);
end
opt1 = opt(1,1);